import os
import sys
import fnmatch
import re

rootdir = sys.argv[1]
includes = ['*utilization_*.rpt','*timing_summary*.rpt'] # for files only
excludes = [] # for dirs and files
#excludes = ['*zynq*', '*old*'] # for dirs and files

# transform glob patterns to regular expressions
includes = r'|'.join([fnmatch.translate(x) for x in includes])
excludes = r'|'.join([fnmatch.translate(x) for x in excludes]) or r'$.'

with open('output.txt','w') as fout:
	for root, dirs, files in os.walk(rootdir):

		# exclude dirs
		dirs[:] = [os.path.join(root, d) for d in dirs]
		dirs[:] = [d for d in dirs if not re.match(excludes, d)]

		# exclude/include files
		files = [os.path.join(root, f) for f in files]
		files = [f for f in files if not re.match(excludes, f)]
		files = [f for f in files if re.match(includes, f)]

		for fname in files:
			dataPathCnt = 0
			with open(os.path.join(root, fname), 'r') as fin:
					for lines in fin:
						if re.match("(.*)Data Path(.*)", lines) and dataPathCnt == 0:
							fout.write(root + '\n')
							fout.write(lines)
							dataPathCnt = 1
						if re.match("(.*)\| Slice  (.*)", lines):
							fout.write(lines)
						if re.match("(.*)Slice LUTs(.*)", lines):
							fout.write(lines);